#!/usr/bin/python3
#  coding:  utf-8
#
#       copyPasteFoldersQt.py
#
#       fileやfolderをclipboardを使ってcopy, pasteする。
#       Qt以外のappに使う。
#
#   20/05/01    新規作成
#      05/02    PyQt4, PyQt5, PySide, PySide2に対応
#

#from PyQt5 import QtCore, QtGui, QtWidgets
try:
    from PyQt5.QtCore import *
    from PyQt5.QtWidgets import *
except:
    try:
        from PySide2.QtCore import *
        from PySide2.QtWidgets import *
    except:
        try:
            from PyQt4.QtCore import *
            from PyQt4.QtGui import *
        except:
            try:
                from PySide.QtCore import *
                from PySide.QtGui import *
            except:
                print("import error: could not import PyQt4, PyQt5, PySide or PySide2!")
                exit()

import os
import pyTreeFoam


#
#  non Qt applicationのために、appを定義する
app = QApplication([])

#
#  copyFolders
#------------
def copyFolders(folders):
    """ folders(fullPath)をsystemのclipboardにコピーする"""

    def paths_to_uris(pathes):
        """ path名をuriに変換して返す。"""
        urls = []
        for path in pathes:
            url = "file://" + os.path.abspath(path)
            urls.append(url)
        return urls

    #sysClipboard = QtWidgets.QApplication.clipboard()
    sysClipboard = app.clipboard()
    sysClipboard.clear(mode=1)

    #mimeTextを作成
    fileMng = pyTreeFoam.fileManager.split("/")[-1].lower()
    #  "x-special/nautilus-clipboard\n"
    copyText = "x-special/" + fileMng + "-clipboard\n"
    copyText += "copy\n"
    copyText += "\n".join(paths_to_uris(folders)) + "\n"
    #mimeUrlsを作成
    mimeData = QMimeData()
    urls = []
    for folder in folders:
        url = QUrl(folder)
        urls.append(url)
    #copyText, urlsをmimeDataにセット
    mimeData.setUrls(urls)              #PyQt4用にセット
    mimeData.setText(copyText)          #fileManager(nautilus)用にセット
    #urls = "\n".join(paths_to_uris(folders)) + "\n"
    #mimeData.setData("text/uri-list", urls.encode())
    #clipboardにmimeDataをセット
    sysClipboard.setMimeData(mimeData)  #clipboardにセット

#
#  pasteFolders
#-------------
def pasteFolders():
    """ systemのclipboardからfoldersを取得して返す。"""
    #sysClipboard = QtWidgets.QApplication.clipboard()
    sysClipboard = app.clipboard()
    mimeData = sysClipboard.mimeData()
    lines = mimeData.text().split("\n")
    if len(lines) < 3:
        return []
    files = []
    for line in lines[2:]:
        if line[:len("file://")] == "file://":
            name = line[len("file://"):]
            files.append(name)
    return files
    #mimeDataからcopyFilesを取得
    # files = []
    # for url in mimeData.urls():
    #     files.append(url.toLocalFile())
    # return files
