#!/usr/bin/python3
#  coding:  utf-8
#
#       copyPasteTextQt.py
#
#       textをclipboardを使って、copy、pasteする。
#       Qtのapp専用になる。
#
#   20/05/01    新規作成
#      05/02    PyQt4, PyQt5, PySide, PySide2に対応
#

#from PyQt5 import QtCore, QtGui, QtWidgets
try:
    from PyQt5.QtCore import *
    from PyQt5.QtWidgets import *
except:
    try:
        from PySide2.QtCore import *
        from PySide2.QtWidgets import *
    except:
        try:
            from PyQt4.QtCore import *
            from PyQt4.QtGui import *
        except:
            try:
                from PySide.QtCore import *
                from PySide.QtGui import *
            except:
                print("import error: could not import PyQt4, PyQt5, PySide or PySide2!")
                exit()

#
#  copyText
#------------
def copyText(text):
    """ textをsystemのClipboardにコピーする"""
    sysClipboard = QApplication.clipboard()
    #sysClipboard = app.clipboard()
    sysClipboard.clear(mode=1)
    mimeData = QMimeData()
    mimeData.setText(text)
    sysClipboard.setMimeData(mimeData)

#
#  pasteText
#------------
def pasteText():
    """ systemのclipboard内からtextを取得して返す。"""
    sysClipboard = QApplication.clipboard()
    #sysClipboard = self.app.clipboard()
    mimeData = sysClipboard.mimeData()
    cont = mimeData.text()
    return cont

